## crawl 0.23.2

=== source/Makefile ===
# vim:set ts=8 sw=4 noexpandtab:
#
# Dungeon Crawl Stone Soup
# GNU Makefile
#
# largely written by Steven Noonan <steven@uplinklabs.net>
#    (if something breaks, blame him.)
#

# Typical targets:
#    make
#    make debug
#    make debug-lite    # Like "make debug", but without all the spew.
#    make install
#    make debug install
#    -- note, unlike most programs, you need to specify build type when
#       installing even if you just built it.
# Typical parameters:
#    TILES         -- set to anything to enable tiles build
#
#    SOUND         -- set to anything to enable sound; note that you will need to
#                     uncomment some lines in sound.h if not building tiles
#
#    CROSSHOST     -- target system, eg, i386-pc-msdosdjgpp or i586-mingw32msvc
#
#    prefix        -- installation base.  Specify eg. /usr/local on Unix systems.
#    DESTDIR       -- installation staging area (the dir you intend to pack)
#    DATADIR       -- place to hold immutable files.  Can be either relative to
#                     "prefix" or absolute.
#    SAVEDIR       -- place to hold writeable data (saves, database, morgue
#                     dumps).  Can be relative to "prefix", absolute or placed
#                     in the user's home dir (~).  Remember to protect the ~
#                     from your shell!
#                     Warning, as of 0.8, directories shared between
#                     multiple system users are no longer supported.
#    SHAREDDIR     -- place to hold writeable data common to multiple
#                     versions of Crawl (scores, the logfile, ghosts).  Will
#                     be placed inside the SAVEDIR if not specified.
#       Layout examples:
#         prefix=~/crawl DATADIR=data/ SAVEDIR=saves/
#                  -- everything under ~/crawl
#         prefix=/usr/local
#                  -- system-wide installation
#
#    V             -- set to anything to enable verbose build
#
#    USE_ICC       -- set to use Intel's compiler
#    LTO           -- set for better optimization but slower compilation,
#                     requires gcc4.6+
#    NO_TRY_GOLD   -- if set don't try to detect a working gold linker
#    NOASSERTS     -- set to disable assertion checks (ignored in debug mode)
#    NOWIZARD      -- set to disable wizard mode.  Use if you have untrusted
#                     remote players without DGL.
#
#    PROPORTIONAL_FONT -- set to a .ttf file you want to use for a proportional
#                         font; if not set, a copy of Bitstream Vera Sans
#                         shipped with Crawl will be used
#    MONOSPACED_FONT   -- monospaced font; Bitstream Vera Mono Sans
#    COPY_FONTS    -- force installing fonts
#
#    WEBTILES      -- set to anything to compile for Webtiles
#    WEBDIR        -- place to hold the Webtiles client data. Can be either
#                     relative to prefix or absolute.
#
#    ANDROID       -- perform an Android build (see docs/develop/android.txt)
#    TOUCH_UI      -- enable UI behaviour more compatible with touch-screens
#
#
# Requirements:
#    For tile builds, you need pkg-config.
#    You also need libpng, sdl2, sdl2-image, sdl2-mixer and libfreetype -- if
#    you got your source from git, you can 'git submodule update' to fetch
#    them; you can also ask for a package with convenience libraries instead --
#    we'll try to provide them somewhere in the near future.

GAME = crawl

# Disable GNU Make implicit rules and variables. Leaving them enabled will slow
# down MinGW and Cygwin builds by a very VERY noticeable degree. Besides, we have
# _explicit_ rules defined for everything. So we don't need them.
MAKEFLAGS += -rR # This only works for recursive makes, i.e. contribs ...
.SUFFIXES:       # ... so zap the suffix list to neutralize most predifined rules, too

.PHONY: all test install clean clean-contrib clean-rltiles clean-android \
        distclean debug debug-lite profile package-source source \
        build-windows package-windows docs greet api api-dev android FORCE \
	monster

include Makefile.obj

#
# Compiler Flags
#
# The compiler flag variables are separated into their individual
# purposes, making it easier to deal with the various tools involved
# in a compile.
#
# These are also divided into global vs. local flags. So for instance,
# CFOPTIMIZE affects Crawl, Lua, and SQLite, while CFOPTIMIZE_L only
# affects Crawl.
#
# The variables are as follows:
# CFOPTIMIZE(_L) - Optimization flags
# CFWARN(_L) - Warning flags
# CFOTHERS(_L) - Anything else
#

# Which C++ standard to support
STDFLAG = -std=c++11

CFOTHERS := -pipe $(EXTERNAL_FLAGS)
CFWARN := 
CFWARN_L := -Wall -Wformat-security -Wundef

DEFINES := $(EXTERNAL_DEFINES)

ifndef ANDROID
LDFLAGS :=
endif

#
# The GCC and GXX variables are set later.
#
AR = ar
RANLIB = ranlib
CC = $(GCC)
CXX = $(GXX)
RM = rm -f
COPY = cp
COPY_R = cp -r
STRIP = strip -s
WINDRES = windres
CHMOD = chmod 2>/dev/null
CHOWN = chown 2>/dev/null
PNGCRUSH = $(COPY)
PNGCRUSH_LABEL = COPY
ADVPNG = advpng -z -2
PKGCONFIG = pkg-config
DOXYGEN = doxygen
DOXYGEN_SIMPLE_CONF = crawl_simple.doxy
DOXYGEN_ALL_CONF = crawl_all.doxy
DOXYGEN_HTML_GEN = html/

export AR
export RANLIB
export RM
export CC
export CXX
export CFLAGS
export STDFLAG
export MAKEFLAGS
export CONFIGURE_FLAGS
export uname_S

#
# Platform Detection
#
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
uname_O := $(shell sh -c 'uname -o 2>/dev/null || echo not')
uname_R := $(shell sh -c 'uname -r 2>/dev/null || echo not')
uname_P := $(shell sh -c 'uname -p 2>/dev/null || echo not')
uname_V := $(shell sh -c 'uname -v 2>/dev/null || echo not')

HOST := $(shell sh -c 'cc -dumpmachine || echo unknown')
ARCH := $(HOST)

ifdef CROSSHOST
	ARCH := $(CROSSHOST)
	ifneq (,$($shell which $(ARCH)-pkg-config 2>/dev/null))
	  PKGCONFIG = $(ARCH)-pkg-config
	else
	  ifneq (,$(wildcard /usr/$(ARCH)/lib/pkgconfig))
	    PKGCONFIG = PKG_CONFIG_LIBDIR=/usr/$(ARCH)/lib/pkgconfig pkg-config
	  else
	    NO_PKGCONFIG = YesPlease
	    BUILD_LUA = yes
	    BUILD_SQLITE = yes
	    BUILD_ZLIB = YesPlease
	  endif
	endif
	NO_AUTO_OPT = YesPlease
	CONFIGURE_FLAGS += --host=$(CROSSHOST)

	# If needed, override uname_S so we get the appropriate
	# things compiled.
	ifneq (,$(findstring mingw,$(CROSSHOST)))
		uname_S=MINGW32
	endif

endif

msys =
ifneq (,$(findstring MINGW,$(uname_S)))
	msys = Yes
endif
ifneq (,$(findstring MSYS,$(uname_S)))
	msys = Yes
endif
ifdef msys
	GAME = crawl.exe
	bin_prefix = .
	WIN32 = Yes
	NO_RDYNAMIC = YesPlease
	NO_NCURSES = YesPlease
	NEED_LIBW32C = YesPlease
	BUILD_PCRE = YesPlease
	BUILD_ZLIB = YesPlease
	SOUND = YesPlease
	DEFINES_L += -DWINMM_PLAY_SOUNDS -D__USE_MINGW_ANSI_STDIO
	EXTRA_LIBS += -lwinmm
	ifdef TILES
		EXTRA_LIBS += -lmingw32 -lgdi32 -lwinmm -limm32 -lole32 -loleaut32 -lversion contrib/install/$(ARCH)/lib/libSDL2main.a -mwindows
		BUILD_FREETYPE = YesPlease
		BUILD_SDL2 = YesPlease
		BUILD_SDL2IMAGE = YesPlease
		BUILD_LIBPNG = YesPlease
		COPY_FONTS = yes
	endif
	ifeq ($(shell gcc -v -static -static-libstdc++ 2>&1 | grep 'unrecognized option'),)
		EXTRA_LIBS += -static -static-libgcc -static-libstdc++
	endif
endif
ifeq ($(uname_S),Darwin)
	STRIP := strip -x
	NEED_APPKIT = YesPlease
	LIBNCURSES_IS_UNICODE = Yes
	NO_PKGCONFIG = Yes
	BUILD_SQLITE = YesPlease
	BUILD_ZLIB = YesPlease
	ifdef TILES
		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework CoreAudio -framework ForceFeedback -framework Carbon -framework IOKit -framework OpenGL -framework AudioToolbox -framework CoreVideo contrib/install/$(ARCH)/lib/libSDL2main.a
		BUILD_FREETYPE = YesPlease
		BUILD_SDL2 = YesPlease
		BUILD_SDL2IMAGE = YesPlease
		ifdef SOUND
			ifndef WIN32 
				BUILD_SDL2MIXER = YesPlease
			endif
		endif
		BUILD_LIBPNG = YesPlease
		COPY_FONTS = yes
	endif
endif
ifdef USE_ICC
	NO_RDYNAMIC := YesPlease
endif
ifneq (,$(findstring CYGWIN,$(uname_S)))
	GAME = crawl.exe
	NO_RDYNAMIC = YesPlease
	BUILD_PCRE = YesPlease
	# newlib doesn't provide Posix functions with c++11
	STDFLAG = -std=gnu++11
endif

ifdef BUILD_ALL
	BUILD_FREETYPE = YesPlease
	BUILD_PCRE = YesPlease
	BUILD_SDL2 = YesPlease
	BUILD_SDL2IMAGE = YesPlease
	ifdef SOUND
		ifndef WIN32 
			BUILD_SDL2MIXER = YesPlease
		endif
	endif
	BUILD_SQLITE = YesPlease
	BUILD_LUA = YesPlease
	BUILD_LIBPNG = YesPlease
	BUILD_ZLIB = YesPlease
endif

# Should be the first rule, but must come after $(GAME) is set.
all: greet check-fonts $(GAME) docs webserver

LIBPCRE := contrib/install/$(ARCH)/lib/libpcre.a
LIBSDL2 := contrib/install/$(ARCH)/lib/libSDL2.a
LIBPNG := contrib/install/$(ARCH)/lib/libpng.a
LIBSDL2IMAGE := contrib/install/$(ARCH)/lib/libSDL2_image.a
LIBSDL2MIXER := contrib/install/$(ARCH)/lib/libSDL2_mixer.a
LIBFREETYPE := contrib/install/$(ARCH)/lib/libfreetype.a
LIBSQLITE := contrib/install/$(ARCH)/lib/libsqlite3.a
ifdef USE_LUAJIT
LIBLUA := contrib/install/$(ARCH)/lib/libluajit.a
else
LIBLUA := contrib/install/$(ARCH)/lib/liblua.a
endif
LIBZ := contrib/install/$(ARCH)/lib/libz.a

ifndef CROSSHOST
	# FreeBSD keeps all of its userland includes in /usr/local so
	# look there
	ifeq ($(uname_S),FreeBSD)
		SQLITE_INCLUDE_DIR := /usr/local/include
	else
		SQLITE_INCLUDE_DIR := /usr/include
	endif
else
	# This is totally wrong, works only with some old-style setups, and
	# on some architectures of Debian/new FHS multiarch -- excluding, for
	# example, i386.  Fortunately, i386 is rarely cross-compiled to.
	# There's no support for /usr/local/ too, without thorough handholding.
	# It's still an improvement over Crawl 0.8 which had no cross-compiling
	# to non-win32 at all.
	#
	# Needs to be replaced by compile checks.  Guessing the paths is fragile,
	# while the compiler knows them already.
	SQLITE_INCLUDE_DIR := /usr/$(ARCH)/include
endif
SQLITE_LIB := -lsqlite3

#
# Set up the TILES variant
#
ifdef TILES
TILES_ANY = YesPlease
OBJECTS += $(TILES_OBJECTS) $(GLTILES_OBJECTS)
  ifdef WEBTILES
    OBJECTS += $(error Web and local tiles are exclusive)
  endif
endif

ifdef WEBTILES
TILES_ANY = YesPlease
OBJECTS += $(TILES_OBJECTS) $(WEBTILES_OBJECTS)
ifdef NO_PKGCONFIG
BUILD_LIBPNG = YesPlease # used by build-rltiles sub-make
endif
endif

ifdef ANDROID
TILES_ANY = YesPlease
endif

#
# Check for an Apple-released compiler.
#
ifndef NO_APPLE_PLATFORM
ifeq ($(uname_S),Darwin)
ifneq ($(shell gcc -v 2>&1 | grep Apple),)
APPLE_PLATFORM = YesPlease
endif
endif
endif


ifdef WIN32
EXTRA_OBJECTS += icon.o
else
ifndef ANDROID
EXTRA_LIBS += -pthread
endif
endif

ifndef TILES
ifdef NEED_LIBW32C
OBJECTS += libw32c.o
else
OBJECTS += libunix.o
endif
endif

# To get stack trace symbols.
# Note that MinGW doesn't support -rdynamic.
ifndef NO_RDYNAMIC
LDFLAGS += -rdynamic
endif

ifdef USE_MERGE_BASE
MERGE_BASE := $(shell git merge-base HEAD $(USE_MERGE_BASE))
endif

ifdef USE_DGAMELAUNCH
# Permissions to set on the game executable.
MCHMOD := 755

# Permissions to set on the save directory.
MCHMOD_SAVEDIR := 775
MCHMOD_LOGS := 664

# The user:group to install the game as.
INSTALL_UGRP := games:games
endif

ifeq ($(patsubst %/local,%,$(patsubst %/,%,$(prefix))),/usr)
FHS := yes
endif

ifeq (,$(bin_prefix))
ifneq ($(patsubst %/,%,$(prefix)),/usr)
bin_prefix    := bin
else
bin_prefix    := games
endif
endif

# If you're installing Crawl for multiple users, you *must* set this to a
# valid path before building Crawl. This is not necessary if you are building
# Crawl for a single user.
# If you're installing to /usr, /usr/local or /opt, we have sane defaults.

# SAVEDIR := saves/
# DATADIR := data/
ifneq (,$(FHS))
DATADIR       := share/crawl
SAVEDIR       := ~/.crawl
endif

ifneq ($(patsubst /opt%,%,$(prefix)),$(prefix))
DATADIR := data
SAVEDIR := ~/.crawl
endif


INCLUDES_L += -Iutil -I.

ifdef APPLE_PLATFORM

ifdef BUILD_UNIVERSAL
# [ds] 10.4 SDK g++-4.0 + x86_64 runs into SDL compile issues.
CFLAGS_ARCH := -arch i386 -arch ppc -faltivec
CFLAGS_DEPCC_ARCH := -arch i386

=== debian/changelog ===
crawl (2:0.23.2-1mx17+1) mx; urgency=medium

  * Rebuild for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 06 Oct 2019 13:21:13 -0700

crawl (2:0.23.2-1mx15+1) mx; urgency=medium

  * Rebuild for MX-15/16.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 06 Oct 2019 12:41:54 -0700

crawl (2:0.23.2-1mx19+1) mx; urgency=medium

  * Rebuild for MX-19.
  * Dropped compat to 11 for lower arch builds.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 06 Oct 2019 11:31:52 -0700

crawl (2:0.23.2-1) unstable; urgency=medium

  * New upstream release
  * Update the watch file.
  * Drop no longer needed NOSSE (fixed upstream).
  * Debhelper 12.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 31 Mar 2019 23:44:55 +0200

crawl (2:0.23.1-2) unstable; urgency=medium

  * Disable forced use of sse2.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 02 Mar 2019 15:34:28 +0100

crawl (2:0.23.1-1) unstable; urgency=medium

  * New upstream release

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 02 Mar 2019 10:41:33 +0100

=== debian/control ===
Source: crawl
Section: games
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Guus Sliepen <guus@debian.org>
Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
Standards-Version: 4.3.0
Build-Depends: debhelper (>= 11), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
	pkg-config, libsdl2-image-dev, libsdl2-mixer-dev, libsdl2-dev, libsqlite3-dev,
	libfreetype6-dev, libpng-dev, python-yaml
Build-Depends-Indep: moreutils, advancecomp
Homepage: http://crawl.develz.org/
Rules-Requires-Root: no

Package: crawl-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: crawl | crawl-tiles
Description: Dungeon Crawl, a text-based roguelike game (data files)
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 These are the data and support files.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
Description: Dungeon Crawl, a text-based roguelike game
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the console version. For tiles, use crawl-tiles instead.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl-tiles-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
Conflicts: crawl-tiles (<< 2:0.11.1-1)
Replaces: crawl-tiles (<< 2:0.11.1-1)
Recommends: crawl-tiles
Description: Dungeon Crawl, a text-based roguelike game (tile data files)
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 These are the tile graphics.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl-tiles
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), crawl-tiles-data (= ${source:Version}), fonts-dejavu-core
Description: Dungeon Crawl, a roguelike game, tiles version
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the graphical (tiles) version.
 .
 This is the Stone Soup version of Dungeon Crawl.

## crawl 0.24.0

=== source/Makefile ===
--- 
+++ 
@@ -109,6 +109,13 @@
 STDFLAG = -std=c++11
 
 CFOTHERS := -pipe $(EXTERNAL_FLAGS)
+# Build with FORCE_SSE=y to get better seed stability on 32 bit x86 builds. It
+# is not recommended to do this unless you are building with contrib lua.
+# On any 64bit  builds where the arch supports it, (at least) sse2 is implied.
+ifdef FORCE_SSE
+CFOTHERS += -mfpmath=sse -msse2
+endif
+
 CFWARN := 
 CFWARN_L := -Wall -Wformat-security -Wundef
 
@@ -167,7 +174,7 @@
 
 ifdef CROSSHOST
 	ARCH := $(CROSSHOST)
-	ifneq (,$($shell which $(ARCH)-pkg-config 2>/dev/null))
+	ifneq (,$(shell which $(ARCH)-pkg-config 2>/dev/null))
 	  PKGCONFIG = $(ARCH)-pkg-config
 	else
 	  ifneq (,$(wildcard /usr/$(ARCH)/lib/pkgconfig))
@@ -254,10 +261,17 @@
 endif
 
 ifdef BUILD_ALL
-	BUILD_FREETYPE = YesPlease
+	ifdef TILES
+		BUILD_FREETYPE = YesPlease
+		BUILD_SDL2 = YesPlease
+		BUILD_SDL2IMAGE = YesPlease
+		BUILD_LIBPNG = YesPlease
+	endif
+	ifdef WEBTILES
+		BUILD_LIBPNG = YesPlease
+	endif
+
 	BUILD_PCRE = YesPlease
-	BUILD_SDL2 = YesPlease
-	BUILD_SDL2IMAGE = YesPlease
 	ifdef SOUND
 		ifndef WIN32 
 			BUILD_SDL2MIXER = YesPlease
@@ -265,7 +279,6 @@
 	endif
 	BUILD_SQLITE = YesPlease
 	BUILD_LUA = YesPlease
-	BUILD_LIBPNG = YesPlease
 	BUILD_ZLIB = YesPlease
 endif
 
@@ -401,21 +414,3 @@
 # SAVEDIR := saves/
 # DATADIR := data/
 ifneq (,$(FHS))
-DATADIR       := share/crawl
-SAVEDIR       := ~/.crawl
-endif
-
-ifneq ($(patsubst /opt%,%,$(prefix)),$(prefix))
-DATADIR := data
-SAVEDIR := ~/.crawl
-endif
-
-
-INCLUDES_L += -Iutil -I.
-
-ifdef APPLE_PLATFORM
-
-ifdef BUILD_UNIVERSAL
-# [ds] 10.4 SDK g++-4.0 + x86_64 runs into SDL compile issues.
-CFLAGS_ARCH := -arch i386 -arch ppc -faltivec
-CFLAGS_DEPCC_ARCH := -arch i386

=== source/util/Makefile ===
YACC := bison -y
LEX  := flex
RM   ?= rm -f

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_YACC     = @echo '   ' YACC $@;
        QUIET_LEX      = @echo '   ' LEX $@;
        export V
endif
endif

all: levcomp.tab.cc levcomp.lex.cc

clean:
	$(RM) levcomp.tab.cc levcomp.tab.h levcomp.lex.cc *.o *.d

%.lex.cc: %.lpp
	$(QUIET_LEX)$(LEX) -o$@ $<
	@perl -pi.orig -e's/register //' $@

%.tab.cc: %.ypp
	$(QUIET_YACC)$(YACC) --defines=$*.tab.h -b $* -o $@ $<

=== debian/changelog ===
crawl (2:0.24.0-1~mx17+1) mx; urgency=medium

  * Rebuild for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 31 Oct 2019 12:48:44 -0700

crawl (2:0.24.0-1~mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 31 Oct 2019 12:14:16 -0700

crawl (2:0.24.0-1) unstable; urgency=medium

  * New upstream release
  * Update the watch file.
  * Use python3; closes: #942923.
  * Fix bogus SQLITE_INCLUDE_DIR; a step towards #871419.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 25 Oct 2019 00:06:10 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
 XSBC-Original-Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Build-Depends: debhelper (>= 11), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl2-image-dev, libsdl2-mixer-dev, libsdl2-dev, libsqlite3-dev,
-	libfreetype6-dev, libpng-dev, python-yaml
+	libfreetype6-dev, libpng-dev, python3-yaml
 Build-Depends-Indep: moreutils, advancecomp
 Homepage: http://crawl.develz.org/
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
        NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
        MAKEFLAGS += -j$(NUMJOBS)
endif

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
  LTO=y
endif
ifneq (,$(findstring x32,$(DEB_HOST_ARCH)))
  LTO=y
endif
ifneq (,$(findstring i386,$(DEB_HOST_ARCH)))
  LTO=y
endif
ifneq (,$(findstring arm64,$(DEB_HOST_ARCH)))
  LTO=y
endif

CFOPTIMIZE = $(shell dpkg-buildflags --get CXXFLAGS || echo -g -O2) \
             $(shell dpkg-buildflags --get LDFLAGS) \
             $(shell dpkg-buildflags --get CPPFLAGS)
ifneq ($(LTO),)
  ifeq ($(shell g++ -x c++ /dev/null -flto=jobserver -fwhole-program 2>&1 | grep 'unrecognized command line option'),)
    CFOPTIMIZE += -flto=jobserver -fwhole-program
  endif
  ifeq ($(shell g++ -x c++ /dev/null -fno-fat-lto-objects 2>&1 | grep 'unrecognized command line option'),)
    CFOPTIMIZE += -fno-fat-lto-objects
  endif
endif

ifeq (,$(filter terse%,$(DEB_BUILD_OPTIONS))$(filter quiet%,$(DEB_BUILD_OPTIONS)))
        VERBOSE=V=y
endif

tree-stamp:
	dh_testdir
	mkdir build-console
	cp -ldpR docs settings source CREDITS.txt build-console/
	mkdir build-tiles
	cp -ldpR docs settings source CREDITS.txt build-tiles/
	touch tree-stamp

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CROSS=CROSSHOST=$(DEB_HOST_GNU_TYPE)
endif

# The makefile is unorthodox, requiring all options to be specified on every invocation.
ARGS_CONSOLE = prefix=/usr CFOPTIMIZE="$(CFOPTIMIZE)" STRIP=: $(CROSS) $(VERBOSE) \
	DIST_BONES_LOC=/dev/null SQLITE_INCLUDE_DIR=/usr/include
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles USE_ADVPNG= \
	PROPORTIONAL_FONT=/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/usr/share/fonts/truetype/dejavu/DejaVuSansMono.ttf

build-arch build-indep: build-stamp
build-stamp: tree-stamp
	dh_testdir

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
	cd build-tiles/source && $(MAKE) $(ARGS_TILES)

	touch build-stamp

# This should be done during build not install but upstream makefile makes
# it hard to isolate the targets the proper way.
install-indep: install
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	if which advpng >/dev/null; then \
	    cd debian/crawl-tiles-data/usr/share/crawl && parallel advpng -z -4 -- \
		`find dat/tiles -name '*.png' -not -name 'title_*' -not -name 'stone_soup*'`; \
	fi
endif

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp tree-stamp
	rm -rf build-console build-tiles

	git clean -dfX || true

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE) install DESTDIR=../../debian/crawl-common
	#cd debian/crawl-common/usr/share && mkdir -p doc/crawl-common && \
	#	mv crawl/docs/* doc/crawl-common && \
	#	mv doc/crawl-common/crawl_manual.txt crawl/docs
	rm -rf debian/crawl-common/usr/share/crawl/docs/license
	mkdir -p debian/crawl/usr/
	mv debian/crawl-common/usr/games debian/crawl/usr/games
	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
	rm -rf debian/crawl-tiles/var
	cd debian/crawl-tiles/usr/share/crawl/ && rm -rf docs settings
	mkdir -p debian/crawl-tiles-data/usr/share/crawl/dat
	mv debian/crawl-tiles/usr/share/crawl/dat/tiles debian/crawl-tiles-data/usr/share/crawl/dat/
	rm -rf debian/crawl-tiles/usr/share/crawl/dat
	
	mkdir -p debian/crawl/usr/share/man/man6
	cp docs/crawl.6 debian/crawl/usr/share/man/man6/
	mkdir -p debian/crawl-tiles/usr/share/man/man6
	cp docs/crawl.6 debian/crawl-tiles/usr/share/man/man6/crawl-tiles.6
	mkdir -p debian/crawl-common/usr/share/doc/crawl-common/examples
	cp settings/init.txt debian/crawl-common/usr/share/doc/crawl-common/examples/crawlrc
	for i in docs/*.txt; do \
		ln -sf /usr/share/crawl/$$i debian/crawl-common/usr/share/doc/crawl-common/; \
	done

	mkdir -p debian/crawl/usr/share/doc
	ln -sf crawl-common debian/crawl/usr/share/doc/crawl
	mkdir -p debian/crawl-tiles/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
	mkdir -p debian/crawl-tiles-data/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles-data/usr/share/doc/crawl-tiles-data
	dh_install -pcrawl debian/crawl.desktop usr/share/applications/
	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications/
	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps/
	dh_link -pcrawl-tiles usr/share/crawl/dat/tiles/stone_soup_icon-32x32.png \
		usr/share/icons/hicolor/32x32/apps/crawl.png
	mkdir -p debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps
	cp -p source/util/dcss.svg \
		debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps/crawl.svg

# Build architecture-independent files here.
binary-indep: install-indep
	dh_testdir
	dh_testroot
	dh_installdocs -pcrawl-common -Xcrawl_manual.txt -Xaptitudes.txt -Xquickstart.txt -Xmacros_guide.txt -Xoptions_guide.txt -Xtiles_help.txt
	dh_installchangelogs -pcrawl-common docs/changelog.txt
	dh_link -i
	dh_compress -i -Xaptitudes.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installmenu -a
	dh_link -a
	dh_compress -a -Xaptitudes.txt
	dh_strip -a --no-automatic-dbgsym
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a -- --ignore-missing-info
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

build: build-indep build-arch
binary: binary-indep binary-arch
.PHONY: build-indep build-arch build clean binary-indep binary-arch binary install

## crawl 0.25.0

=== source/Makefile ===
--- 
+++ 
@@ -47,6 +47,7 @@
 #    USE_ICC       -- set to use Intel's compiler
 #    LTO           -- set for better optimization but slower compilation,
 #                     requires gcc4.6+
+#    NO_TRY_LLD    -- if set don't try to detect a working lld linker
 #    NO_TRY_GOLD   -- if set don't try to detect a working gold linker
 #    NOASSERTS     -- set to disable assertion checks (ignored in debug mode)
 #    NOWIZARD      -- set to disable wizard mode.  Use if you have untrusted
@@ -82,9 +83,11 @@
 .SUFFIXES:       # ... so zap the suffix list to neutralize most predifined rules, too
 
 .PHONY: all test install clean clean-contrib clean-rltiles clean-android \
+        clean-catch2 clean-plug-and-play-tests \
+		clean-coverage clean-coverage-full \
         distclean debug debug-lite profile package-source source \
-        build-windows package-windows docs greet api api-dev android FORCE \
-	monster
+        build-windows package-windows-installer docs greet api api-dev android FORCE \
+        monster catch2-tests plug-and-play-tests
 
 include Makefile.obj
 
@@ -116,8 +119,20 @@
 CFOTHERS += -mfpmath=sse -msse2
 endif
 
-CFWARN := 
+CFWARN :=
 CFWARN_L := -Wall -Wformat-security -Wundef
+
+# Exceptions:
+#  -Wmissing-field-initializers: need c++14 to set default struct fields
+#  -Wimplicit-fallthrough: need c++17 for [[fallthrough]]
+#  -Wtype-limits: mostly complains about ASSERT_RANGE, and _Pragma is buggy on
+#      old g++ anyway: re-enable when we bump the minimum g++ version
+#  -Wuninitialized: added later in this makefile, conditional on NO_OPTIMIZE
+CFWARN_L += -Wextra \
+	    -Wno-missing-field-initializers \
+	    -Wno-implicit-fallthrough \
+	    -Wno-type-limits \
+	    -Wno-uninitialized \
 
 DEFINES := $(EXTERNAL_DEFINES)
 
@@ -136,6 +151,7 @@
 COPY = cp
 COPY_R = cp -r
 STRIP = strip -s
+SED = sed
 WINDRES = windres
 CHMOD = chmod 2>/dev/null
 CHOWN = chown 2>/dev/null
@@ -147,6 +163,11 @@
 DOXYGEN_SIMPLE_CONF = crawl_simple.doxy
 DOXYGEN_ALL_CONF = crawl_all.doxy
 DOXYGEN_HTML_GEN = html/
+# Prefer python3, if available
+PYTHON = python
+ifneq (, $(shell which python3 2>&1))
+	PYTHON = python3
+endif
 
 export AR
 export RANLIB
@@ -164,10 +185,6 @@
 #
 uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
 uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
-uname_O := $(shell sh -c 'uname -o 2>/dev/null || echo not')
-uname_R := $(shell sh -c 'uname -r 2>/dev/null || echo not')
-uname_P := $(shell sh -c 'uname -p 2>/dev/null || echo not')
-uname_V := $(shell sh -c 'uname -v 2>/dev/null || echo not')
 
 HOST := $(shell sh -c 'cc -dumpmachine || echo unknown')
 ARCH := $(HOST)
@@ -208,7 +225,6 @@
 	GAME = crawl.exe
 	bin_prefix = .
 	WIN32 = Yes
-	NO_RDYNAMIC = YesPlease
 	NO_NCURSES = YesPlease
 	NEED_LIBW32C = YesPlease
 	BUILD_PCRE = YesPlease
@@ -241,7 +257,7 @@
 		BUILD_SDL2 = YesPlease
 		BUILD_SDL2IMAGE = YesPlease
 		ifdef SOUND
-			ifndef WIN32 
+			ifndef WIN32
 				BUILD_SDL2MIXER = YesPlease
 			endif
 		endif
@@ -249,12 +265,8 @@
 		COPY_FONTS = yes
 	endif
 endif
-ifdef USE_ICC
-	NO_RDYNAMIC := YesPlease
-endif
 ifneq (,$(findstring CYGWIN,$(uname_S)))
 	GAME = crawl.exe
-	NO_RDYNAMIC = YesPlease
 	BUILD_PCRE = YesPlease
 	# newlib doesn't provide Posix functions with c++11
 	STDFLAG = -std=gnu++11
@@ -273,7 +285,7 @@
 
 	BUILD_PCRE = YesPlease
 	ifdef SOUND
-		ifndef WIN32 
+		ifndef WIN32
 			BUILD_SDL2MIXER = YesPlease
 		endif
 	endif
@@ -299,28 +311,6 @@
 endif
 LIBZ := contrib/install/$(ARCH)/lib/libz.a
 
-ifndef CROSSHOST
-	# FreeBSD keeps all of its userland includes in /usr/local so
-	# look there
-	ifeq ($(uname_S),FreeBSD)
-		SQLITE_INCLUDE_DIR := /usr/local/include
-	else
-		SQLITE_INCLUDE_DIR := /usr/include
-	endif
-else
-	# This is totally wrong, works only with some old-style setups, and
-	# on some architectures of Debian/new FHS multiarch -- excluding, for
-	# example, i386.  Fortunately, i386 is rarely cross-compiled to.
-	# There's no support for /usr/local/ too, without thorough handholding.
-	# It's still an improvement over Crawl 0.8 which had no cross-compiling
-	# to non-win32 at all.
-	#
-	# Needs to be replaced by compile checks.  Guessing the paths is fragile,
-	# while the compiler knows them already.
-	SQLITE_INCLUDE_DIR := /usr/$(ARCH)/include
-endif
-SQLITE_LIB := -lsqlite3
-
 #
 # Set up the TILES variant
 #
@@ -372,12 +362,6 @@
 endif
 endif
 
-# To get stack trace symbols.
-# Note that MinGW doesn't support -rdynamic.
-ifndef NO_RDYNAMIC
-LDFLAGS += -rdynamic
-endif
-
 ifdef USE_MERGE_BASE
 MERGE_BASE := $(shell git merge-base HEAD $(USE_MERGE_BASE))
 endif
@@ -414,3 +398,23 @@
 # SAVEDIR := saves/
 # DATADIR := data/
 ifneq (,$(FHS))
+DATADIR       := share/crawl
+SAVEDIR       := ~/.crawl
+endif
+
+ifneq ($(patsubst /opt%,%,$(prefix)),$(prefix))
+DATADIR := data
+SAVEDIR := ~/.crawl
+endif
+
+
+INCLUDES_L += -Iutil -I.
+
+ifdef APPLE_PLATFORM
+
+ifdef BUILD_UNIVERSAL
+# [ds] 10.4 SDK g++-4.0 + x86_64 runs into SDL compile issues.
+CFLAGS_ARCH := -arch i386 -arch ppc -faltivec
+CFLAGS_DEPCC_ARCH := -arch i386
+NO_INLINE_DEPGEN := YesPlease
+else

=== debian/changelog ===
crawl (2:0.25.0-1) unstable; urgency=medium

  * New upstream release.
  * Fixes CVE-2020-11722; closes: #958232.
  * Clean up MacOS droppings.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 13 Jul 2020 17:30:36 +0200

## crawl 0.25.1

=== debian/changelog ===
crawl (2:0.25.1-1mx19+1) mx; urgency=medium

  * Rebuild for MX-19

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 26 Jul 2020 19:41:38 -0700

## crawl 0.26.0

=== debian/changelog ===
crawl (2:0.26.0-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 09 Jan 2021 06:49:04 +0100

crawl (2:0.25.1-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 31 Aug 2020 11:25:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: crawl
 Section: games
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Guus Sliepen <guus@debian.org>
+Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-Standards-Version: 4.4.1
-Build-Depends: debhelper (>= 11), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
+Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 12), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl2-image-dev, libsdl2-mixer-dev, libsdl2-dev, libsqlite3-dev,
 	libfreetype6-dev, libpng-dev, python3-yaml
 Build-Depends-Indep: moreutils, advancecomp

## crawl 0.26.1

=== source/Makefile ===
--- 
+++ 
@@ -248,21 +248,27 @@
 	STRIP := strip -x
 	NEED_APPKIT = YesPlease
 	LIBNCURSES_IS_UNICODE = Yes
-	NO_PKGCONFIG = Yes
-	BUILD_SQLITE = YesPlease
-	BUILD_ZLIB = YesPlease
 	ifdef TILES
-		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework CoreAudio -framework ForceFeedback -framework Carbon -framework IOKit -framework OpenGL -framework AudioToolbox -framework CoreVideo contrib/install/$(ARCH)/lib/libSDL2main.a
-		BUILD_FREETYPE = YesPlease
-		BUILD_SDL2 = YesPlease
-		BUILD_SDL2IMAGE = YesPlease
-		ifdef SOUND
-			ifndef WIN32
-				BUILD_SDL2MIXER = YesPlease
+		EXTRA_LIBS += -framework AppKit -framework AudioUnit -framework CoreAudio -framework ForceFeedback -framework Carbon -framework IOKit -framework OpenGL -framework AudioToolbox -framework CoreVideo
+		COPY_FONTS = yes
+	endif
+	ifndef FORCE_PKGCONFIG
+		NO_PKGCONFIG = Yes
+		# is any of this stuff actually needed if NO_PKGCONFIG is set?
+		BUILD_SQLITE = YesPlease
+		BUILD_ZLIB = YesPlease
+		ifdef TILES
+			EXTRA_LIBS += contrib/install/$(ARCH)/lib/libSDL2main.a
+			BUILD_FREETYPE = YesPlease
+			BUILD_SDL2 = YesPlease
+			BUILD_SDL2IMAGE = YesPlease
+			ifdef SOUND
+				ifndef WIN32
+					BUILD_SDL2MIXER = YesPlease
+				endif
 			endif
+			BUILD_LIBPNG = YesPlease
 		endif
-		BUILD_LIBPNG = YesPlease
-		COPY_FONTS = yes
 	endif
 endif
 ifneq (,$(findstring CYGWIN,$(uname_S)))
@@ -413,8 +419,3 @@
 ifdef APPLE_PLATFORM
 
 ifdef BUILD_UNIVERSAL
-# [ds] 10.4 SDK g++-4.0 + x86_64 runs into SDL compile issues.
-CFLAGS_ARCH := -arch i386 -arch ppc -faltivec
-CFLAGS_DEPCC_ARCH := -arch i386
-NO_INLINE_DEPGEN := YesPlease
-else

=== debian/changelog ===
crawl (2:0.26.1-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 05 Feb 2021 16:46:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Build-Depends: debhelper-compat (= 12), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl2-image-dev, libsdl2-mixer-dev, libsdl2-dev, libsqlite3-dev,
 	libfreetype6-dev, libpng-dev, python3-yaml

=== debian/rules ===
--- 
+++ 
@@ -84,6 +84,7 @@
 	rm -rf build-console build-tiles
 
 	git clean -dfX || true
+	find -name '._*' -execdir rm '{}' +
 
 	dh_clean
 
@@ -153,7 +154,7 @@
 	dh_installmenu -a
 	dh_link -a
 	dh_compress -a -Xaptitudes.txt
-	dh_strip -a --no-automatic-dbgsym
+	dh_strip -a
 	dh_fixperms -a
 	dh_installdeb -a
 	dh_shlibdeps -a -- --ignore-missing-info
@@ -164,5 +165,3 @@
 build: build-indep build-arch
 binary: binary-indep binary-arch
 .PHONY: build-indep build-arch build clean binary-indep binary-arch binary install
-
-

=== debian/watch ===
version=3
opts="uversionmangle=s/\-nodeps// dversionmangle=s/\+dfsg\d*$//" \
http://crawl.develz.org/release/stone_soup-(.+)\.t(?:ar.)?(?:gz|bz2|xz)

## crawl 0.27.1

=== debian/changelog ===
crawl (2:0.27.1-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 15 Sep 2021 23:33:46 +0200

crawl (2:0.27.0-1) unstable; urgency=medium

  * New upstream release.
  * Use the new location of the SVG icon.
  * Drop ancient conflicts+replaces.
  * dh 13.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 14 Aug 2021 15:57:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
 Standards-Version: 4.5.1
-Build-Depends: debhelper-compat (= 12), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
+Build-Depends: debhelper-compat (= 13), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl2-image-dev, libsdl2-mixer-dev, libsdl2-dev, libsqlite3-dev,
 	libfreetype6-dev, libpng-dev, python3-yaml
 Build-Depends-Indep: moreutils, advancecomp
@@ -41,8 +41,6 @@
 Package: crawl-tiles-data
 Architecture: all
 Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
-Conflicts: crawl-tiles (<< 2:0.11.1-1)
-Replaces: crawl-tiles (<< 2:0.11.1-1)
 Recommends: crawl-tiles
 Description: Dungeon Crawl, a text-based roguelike game (tile data files)
  Crawl is a fun game in the grand tradition of games like Rogue, Hack, and

## crawl 0.28.0

=== source/Makefile ===
--- 
+++ 
@@ -66,6 +66,20 @@
 #    ANDROID       -- perform an Android build (see docs/develop/android.txt)
 #    TOUCH_UI      -- enable UI behaviour more compatible with touch-screens
 #
+# For various mac build tricks oriented at release builds see the various
+# mac-app-* targets as well as the crawl-universal target. (For normal dev
+# circumstances, none of this is needed.)
+#
+# There are a number of #defines that may be useful for downstream packaging
+# or custom server setups. See AppHdr.h for more details. Of note:
+#
+#    VERSIONED_CACHE_DIR -- use a cache dir per version, rather than a shared
+#                           cache dir across versions. This may be useful for
+#                           reproducible builds, since the shared cache
+#                           directory makes use of mtimes.
+#
+# To set defines from the command line while building, use EXTERNAL_DEFINES.
+# E.g.: make EXTERNAL_DEFINES="-DVERSIONED_CACHE_DIR"
 #
 # Requirements:
 #    For tile builds, you need pkg-config.
@@ -74,7 +88,12 @@
 #    them; you can also ask for a package with convenience libraries instead --
 #    we'll try to provide them somewhere in the near future.
 
-GAME = crawl
+# allow overriding GAME at the command line, intended for downstream packaging
+# processes. Not supported for MSYS2/cygwin builds, and will be overridden for
+# mac universal builds. This does not count as a change in build flags.
+ifndef GAME
+	GAME = crawl
+endif
 
 # Disable GNU Make implicit rules and variables. Leaving them enabled will slow
 # down MinGW and Cygwin builds by a very VERY noticeable degree. Besides, we have
@@ -87,7 +106,8 @@
 		clean-coverage clean-coverage-full \
         distclean debug debug-lite profile package-source source \
         build-windows package-windows-installer docs greet api api-dev android FORCE \
-        monster catch2-tests plug-and-play-tests
+        monster catch2-tests plug-and-play-tests \
+        crawl-universal crawl-arm64-apple-macos11 crawl-x86_64-apple-macos10.7 clean-mac
 
 include Makefile.obj
 
@@ -245,6 +265,12 @@
 	endif
 endif
 ifeq ($(uname_S),Darwin)
+ifdef MAC_TARGET
+	# for reasons I really cannot figure out, setting GAME later (when the
+	# other MAC_TARGET checks are done) really does not work.
+	GAME = crawl-$(MAC_TARGET)
+endif
+
 	STRIP := strip -x
 	NEED_APPKIT = YesPlease
 	LIBNCURSES_IS_UNICODE = Yes
@@ -353,69 +379,3 @@
 
 
 ifdef WIN32
-EXTRA_OBJECTS += icon.o
-else
-ifndef ANDROID
-EXTRA_LIBS += -pthread
-endif
-endif
-
-ifndef TILES
-ifdef NEED_LIBW32C
-OBJECTS += libw32c.o
-else
-OBJECTS += libunix.o
-endif
-endif
-
-ifdef USE_MERGE_BASE
-MERGE_BASE := $(shell git merge-base HEAD $(USE_MERGE_BASE))
-endif
-
-ifdef USE_DGAMELAUNCH
-# Permissions to set on the game executable.
-MCHMOD := 755
-
-# Permissions to set on the save directory.
-MCHMOD_SAVEDIR := 775
-MCHMOD_LOGS := 664
-
-# The user:group to install the game as.
-INSTALL_UGRP := games:games
-endif
-
-ifeq ($(patsubst %/local,%,$(patsubst %/,%,$(prefix))),/usr)
-FHS := yes
-endif
-
-ifeq (,$(bin_prefix))
-ifneq ($(patsubst %/,%,$(prefix)),/usr)
-bin_prefix    := bin
-else
-bin_prefix    := games
-endif
-endif
-
-# If you're installing Crawl for multiple users, you *must* set this to a
-# valid path before building Crawl. This is not necessary if you are building
-# Crawl for a single user.
-# If you're installing to /usr, /usr/local or /opt, we have sane defaults.
-
-# SAVEDIR := saves/
-# DATADIR := data/
-ifneq (,$(FHS))
-DATADIR       := share/crawl
-SAVEDIR       := ~/.crawl
-endif
-
-ifneq ($(patsubst /opt%,%,$(prefix)),$(prefix))
-DATADIR := data
-SAVEDIR := ~/.crawl
-endif
-
-
-INCLUDES_L += -Iutil -I.
-
-ifdef APPLE_PLATFORM
-
-ifdef BUILD_UNIVERSAL

=== source/webserver/Makefile ===
lint:
	flake8 --mypy-config=mypy.ini *.py


format:
	isort --check-only --recursive .


.PHONY: lint format

=== debian/changelog ===
crawl (2:0.28.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add libglu-dev to build deps (Closes: #1022308)

 -- Paul Wise <pabs@debian.org>  Wed, 07 Dec 2022 10:11:32 +0800

crawl (2:0.28.0-1) unstable; urgency=medium

  * Team upload.
  * Drop myself from uploaders.
  * New upstream release.
  * Point the watch file to Github releases.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 24 Feb 2022 00:12:07 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: games
 Priority: optional
 Maintainer: Guus Sliepen <guus@debian.org>
-Uploaders: Trent W. Buck <trentbuck@gmail.com>, Adam Borowski <kilobyte@angband.pl>
-Standards-Version: 4.5.1
+Uploaders: Trent W. Buck <trentbuck@gmail.com>
+Standards-Version: 4.6.0
 Build-Depends: debhelper-compat (= 13), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl2-image-dev, libsdl2-mixer-dev, libsdl2-dev, libsqlite3-dev,
-	libfreetype6-dev, libpng-dev, python3-yaml
+	libfreetype6-dev, libpng-dev, python3-yaml, libglu-dev
 Build-Depends-Indep: moreutils, advancecomp
 Homepage: http://crawl.develz.org/
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -130,7 +130,7 @@
 	dh_link -pcrawl-tiles usr/share/crawl/dat/tiles/stone_soup_icon-32x32.png \
 		usr/share/icons/hicolor/32x32/apps/crawl.png
 	mkdir -p debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps
-	cp -p source/util/dcss.svg \
+	cp -p source/dat/tiles/stone_soup_icon.svg \
 		debian/crawl-tiles/usr/share/icons/hicolor/scalable/apps/crawl.svg
 
 # Build architecture-independent files here.

## crawl 0.30.0

=== debian/changelog ===
crawl (2:0.30.0-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 25 May 2023 06:23:51 -0700

## crawl 0.30.1

=== source/Makefile ===
--- 
+++ 
@@ -63,8 +63,8 @@
 #    WEBDIR        -- place to hold the Webtiles client data. Can be either
 #                     relative to prefix or absolute.
 #
+#    LINUXDEPLOY   -- path to linuxdeploy tool, required for AppImage builds
 #    ANDROID       -- perform an Android build (see docs/develop/android.txt)
-#    TOUCH_UI      -- enable UI behaviour more compatible with touch-screens
 #
 # For various mac build tricks oriented at release builds see the various
 # mac-app-* targets as well as the crawl-universal target. (For normal dev
@@ -102,9 +102,9 @@
 .SUFFIXES:       # ... so zap the suffix list to neutralize most predifined rules, too
 
 .PHONY: all test install clean clean-contrib clean-rltiles clean-android \
-        clean-catch2 clean-plug-and-play-tests \
-		clean-coverage clean-coverage-full \
-        distclean debug debug-lite profile package-source source \
+        clean-appimage clean-catch2 clean-plug-and-play-tests \
+        clean-coverage clean-coverage-full \
+        appimage distclean debug debug-lite profile package-source source \
         build-windows package-windows-installer docs greet api api-dev android FORCE \
         monster catch2-tests plug-and-play-tests \
         crawl-universal crawl-arm64-apple-macos11 crawl-x86_64-apple-macos10.7 clean-mac
@@ -210,6 +210,7 @@
 ARCH := $(HOST)
 
 ifdef CROSSHOST
+	# XX is there a way of integrating this with mac cross-compiling?
 	ARCH := $(CROSSHOST)
 	ifneq (,$(shell which $(ARCH)-pkg-config 2>/dev/null))
 	  PKGCONFIG = $(ARCH)-pkg-config
@@ -249,6 +250,7 @@
 	NEED_LIBW32C = YesPlease
 	BUILD_PCRE = YesPlease
 	BUILD_ZLIB = YesPlease
+	BUILD_SQLITE = YesPlease
 	SOUND = YesPlease
 	DEFINES_L += -DWINMM_PLAY_SOUNDS -D__USE_MINGW_ANSI_STDIO
 	EXTRA_LIBS += -lwinmm
@@ -329,6 +331,7 @@
 # Should be the first rule, but must come after $(GAME) is set.
 all: greet check-fonts $(GAME) docs webserver
 
+# XX these are set wrong on mac cross-compiling
 LIBPCRE := contrib/install/$(ARCH)/lib/libpcre.a
 LIBSDL2 := contrib/install/$(ARCH)/lib/libSDL2.a
 LIBPNG := contrib/install/$(ARCH)/lib/libpng.a
@@ -367,15 +370,3 @@
 endif
 
 #
-# Check for an Apple-released compiler.
-#
-ifndef NO_APPLE_PLATFORM
-ifeq ($(uname_S),Darwin)
-ifneq ($(shell gcc -v 2>&1 | grep Apple),)
-APPLE_PLATFORM = YesPlease
-endif
-endif
-endif
-
-
-ifdef WIN32

=== debian/changelog ===
crawl (2:0.30.1-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 11 Nov 2023 12:40:09 -0800

## crawl 0.31.0

=== debian/changelog ===
crawl (2:0.31.0-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 11 Feb 2024 07:29:20 -0800

## crawl 0.32.1

=== debian/changelog ===
crawl (2:0.32.1-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 18 Oct 2024 09:22:23 -0700

## crawl 0.33.0

=== debian/changelog ===
crawl (2:0.33.0-1mx25+1) mx; urgency=medium

  * Rebuild for MX-25.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 16 May 2025 20:41:14 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: crawl
 Section: games
 Priority: optional
-Maintainer: Guus Sliepen <guus@debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Guus Sliepen <guus@debian.org>
 Uploaders: Trent W. Buck <trentbuck@gmail.com>
 Standards-Version: 4.6.0
 Build-Depends: debhelper-compat (= 13), libncursesw5-dev, bison, flex, liblua5.1-0-dev,

=== debian/rules ===
--- 
+++ 
@@ -154,7 +154,7 @@
 	dh_installmenu -a
 	dh_link -a
 	dh_compress -a -Xaptitudes.txt
-	dh_strip -a
+	dh_strip -a --no-automatic-dbgsym
 	dh_fixperms -a
 	dh_installdeb -a
 	dh_shlibdeps -a -- --ignore-missing-info
